Allow parallel testing

2021-04-04 15:47 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Rails support Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution: Fixed   

Description

Rails 6.0 or later supports parallel testing. Enabling this feature can reduce the time required for testing and improve development

efficiency.

https://guides.rubyonrails.org/testing.html#parallel-testing

By applying the following patch and run the test suite with PARALLEL_WORKERS=6 environment variable in my environment, the

time required to run the test suite was reduced to about 30%.

diff --git a/test/test_helper.rb b/test/test_helper.rb

index 10f4f6e35..95b877d44 100644

--- a/test/test_helper.rb

+++ b/test/test_helper.rb

@@ -53,6 +53,8 @@ class ActionView::TestCase

 end

 class ActiveSupport::TestCase

+  parallelize(workers: 1)

+

   include ActionDispatch::TestProcess

   self.use_transactional_tests = true

 The reason why the number of workers is set to 1 is that parallel testing causes some errors in system test.

Associated revisions

Revision 20920 - 2021-04-06 08:27 - Go MAEDA

Allow parallel testing (#35030).

Patch by Go MAEDA.

Revision 20928 - 2021-04-12 07:21 - Go MAEDA

Update svn:ignore to ignore SQLite3 databases for parallel testing (#35030).

Revision 20929 - 2021-04-12 07:25 - Go MAEDA

Update .gitignore to ignore SQLite3 databases for parallel testing (#35030).

Revision 20930 - 2021-04-12 07:27 - Go MAEDA

Update .hgignore to ignore SQLite3 databases for parallel testing (#35030).

History

#1 - 2021-04-06 02:20 - Go MAEDA

- File 35030.patch added

- Subject changed from Enable parallel testing to Allow parallel testing

- Target version set to 5.0.0

Setting the target version to 5.0.0.

2025-05-01 1/2

https://guides.rubyonrails.org/testing.html#parallel-testing


#2 - 2021-04-06 08:29 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the change.

Now you can run tests in parallel by setting PARALLEL_WORKERS environment variable.

PARALLEL_WORKERS=8 bin/rails test

#3 - 2021-04-06 11:17 - Go MAEDA

- Description updated

Files

35030.patch 907 Bytes 2021-04-06 Go MAEDA
